DO I=0, N-1 
AB(13,7*I+1) = 2.E+0_DP*y(I+1)-2.E+0_DP*y(I)
AB(13,7*I+2) = 3.333333333333333E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(13,7*I+3) = 2.E-1_DP*(2.E+0_DP*y(I+1)-2.E+0_DP*y(I))
AB(13,7*I+4) = 1.4285714285714285E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(13,7*I+5) = 1.1111111111111112E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
ENDDO 
DO I=1, N 

IF (7*I-13>0 ) AB(15,7*I-8) = 1.E+0_DP
IF ( N2>=7*I-1) AB(8,7*I-1) = -1.E+0_DP
IF ( N2>=7*I-1) AB(18,7*I-6) = -1.E+0_DP
IF ( N2>=7*I-1) AB(11,7*I+1) = 1.E+0_DP

IF (7*I-13>0 ) AB(16,7*I-8) = -1.E+0_DP
IF ( N2>=7*I-1) AB(9,7*I-1) = -1.E+0_DP
IF ( N2>=7*I-1) AB(17,7*I-5) = -1.E+0_DP
IF ( N2>=7*I-1) AB(10,7*I+2) = -1.E+0_DP
IF (7*I-12>0 ) AB(15,7*I-7) = (2.E+0_DP*y(I-1)-2.E&
	&+0_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=7*I) AB(8,7*I) = -2.E+0_DP
IF ( N2>=7*I) AB(18,7*I-5) = -2.E+0_DP
IF ( N2>=7*I) AB(11,7*I+2) = (2.E+0_DP*y(I)-2.E+0_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))

IF (7*I-13>0 ) AB(17,7*I-8) = 1.E+0_DP
IF ( N2>=7*I-1) AB(10,7*I-1) = -1.E+0_DP
IF ( N2>=7*I-1) AB(16,7*I-4) = -1.E+0_DP
IF ( N2>=7*I-1) AB(9,7*I+3) = 1.E+0_DP
IF (7*I-12>0 ) AB(16,7*I-7) = (6.E+0_DP*y(I-2)-6.E&
	&+0_DP*y(I-1))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=7*I) AB(9,7*I) = -6.E+0_DP
IF ( N2>=7*I) AB(17,7*I-4) = -6.E+0_DP
IF ( N2>=7*I) AB(10,7*I+3) = (6.E+0_DP*y(I-1)-6.E+0_DP&
	&*y(I))/(y(I+1)-1.E+0_DP*y(I))

IF (7*I-13>0 ) AB(18,7*I-8) = -1.E+0_DP
IF ( N2>=7*I-1) AB(11,7*I-1) = -1.E+0_DP
IF ( N2>=7*I-1) AB(15,7*I-3) = -1.E+0_DP
IF ( N2>=7*I-1) AB(8,7*I+4) = -1.E+0_DP
IF (7*I-12>0 ) AB(17,7*I-7) = (1.2E+1_DP*y(I-1)-1.2E&
	&+1_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=7*I) AB(10,7*I) = -1.2E+1_DP
IF ( N2>=7*I) AB(16,7*I-3) = -1.2E+1_DP
IF ( N2>=7*I) AB(9,7*I+4) = (1.2E+1_DP*y(I)-1.2E+1_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))

IF (7*I-13>0 ) AB(19,7*I-8) = 1.E+0_DP
IF ( N2>=7*I-1) AB(12,7*I-1) = -1.E+0_DP
IF ( N2>=7*I-1) AB(14,7*I-2) = -1.E+0_DP
IF ( N2>=7*I-1) AB(7,7*I+5) = 1.E+0_DP
IF (7*I-12>0 ) AB(18,7*I-7) = (2.E+1_DP*y(I-2)-2.E&
	&+1_DP*y(I-1))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=7*I) AB(11,7*I) = -2.E+1_DP
IF ( N2>=7*I) AB(15,7*I-2) = -2.E+1_DP
IF ( N2>=7*I) AB(8,7*I+5) = (2.E+1_DP*y(I-1)-2.E+1_DP&
	&*y(I))/(y(I+1)-1.E+0_DP*y(I))
ENDDO 
